/******************************************************************************
 * @file     main.c
 * @brief    Main program body
 * @version  V1.8.0
 * @date     31-Dec-2021
 *
 * @note
 * Copyright (C) 2021 Spintrol Limited Corporation. All rights reserved.
 *
 * @attention
 * THIS SOFTWARE JUST PROVIDES CUSTOMERS WITH CODING INFORMATION REGARDING
 * THEIR PRODUCTS, WHICH AIMS AT SAVING TIME FOR THEM. SPINTROL SHALL NOT BE
 * LIABLE FOR THE USE OF THE SOFTWARE. SPINTROL DOES NOT GUARANTEE THE
 * CORRECTNESS OF THIS SOFTWARE AND RESERVES THE RIGHT TO MODIFY THE SOFTWARE
 * WITHOUT NOTIFICATION.
 *
 ******************************************************************************/

#include"spc1168.h"
#include<stdio.h>

int main()
{
  FLASH_WALLOW();
  
  FLASH_SetTiming(200000000);
  
  CLOCK_InitWithRCO(CLOCK_HCLK_200MHZ);
  
  /*Disable flash write access after flash operation had done*/
  FLASH_WDIS();
  
  Delay_Init();

  /*
   * Init the UART
   *
   * 1.Set the GPIO34/35 as UART FUNC
   *
   * 2.Enable the UART CLK
   *
   * 3.Set the rest para
   */
  GPIO_SetPinChannel(GPIO_34,GPIO34_UART_TXD);
  GPIO_SetPinChannel(GPIO_35,GPIO35_UART_RXD);
  CLOCK_EnableModule(UART_MODULE);
  UART_Init(UART,38400);
  
  /* Init WDT0 and set count time to 500ms */
  WDT_Init(WDT0, 500);
  
  /* Enable the counter and the interruput */
  WDT_EnableInt(WDT0);
  
  while(1)
  {
    
  }
}

/* In our solution, WDT0 INT connected to SYS NMI */
void NMI_Handler()
{
  /* Clear INT, So that SYS would restart */
  WDT_ClearInt(WDT0);

  /* Set WDT0 Stop count and disable the INT */
  WDT_DisableInt(WDT0);

  printf("WDT INT test OK\n");
}
